package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.Policies.Create(ctx, nil)
if err != nil {
log.Fatal(err)
}
if res.CreatePolicyResponse != nil {
// handle response
}
}import { ConductoroneSDKTypescript } from "conductorone-sdk-typescript";
const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
security: {
bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
oauth: "<YOUR_OAUTH_HERE>",
},
});
async function run() {
const result = await conductoroneSDKTypescript.policies.create();
console.log(result);
}
run();curl --request POST \
--url https://{tenantDomain}.conductor.one/api/v1/policies \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"displayName": "<string>",
"description": "<string>",
"policySteps": {},
"postActions": [
{
"certifyRemediateImmediately": true
}
],
"reassignTasksToDelegates": true,
"rules": [
{
"condition": "<string>",
"policyKey": "<string>"
}
]
}
'import requests
url = "https://{tenantDomain}.conductor.one/api/v1/policies"
payload = {
"displayName": "<string>",
"description": "<string>",
"policySteps": {},
"postActions": [{ "certifyRemediateImmediately": True }],
"reassignTasksToDelegates": True,
"rules": [
{
"condition": "<string>",
"policyKey": "<string>"
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
displayName: '<string>',
description: '<string>',
policySteps: {},
postActions: [{certifyRemediateImmediately: true}],
reassignTasksToDelegates: true,
rules: [{condition: '<string>', policyKey: '<string>'}]
})
};
fetch('https://{tenantDomain}.conductor.one/api/v1/policies', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"policy": {
"createdAt": "2023-11-07T05:31:56Z",
"deletedAt": "2023-11-07T05:31:56Z",
"description": "<string>",
"displayName": "<string>",
"id": "<string>",
"policySteps": {},
"postActions": [
{
"certifyRemediateImmediately": true
}
],
"reassignTasksToDelegates": true,
"rules": [
{
"condition": "<string>",
"policyKey": "<string>"
}
],
"systemBuiltin": true,
"updatedAt": "2023-11-07T05:31:56Z"
}
}Create
Create a policy.
package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.Policies.Create(ctx, nil)
if err != nil {
log.Fatal(err)
}
if res.CreatePolicyResponse != nil {
// handle response
}
}import { ConductoroneSDKTypescript } from "conductorone-sdk-typescript";
const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
security: {
bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
oauth: "<YOUR_OAUTH_HERE>",
},
});
async function run() {
const result = await conductoroneSDKTypescript.policies.create();
console.log(result);
}
run();Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
This API uses OAuth2 with the Client Credential flow. Client Credentials must be sent in the BODY, not the headers. For an example of how to implement this, refer to the c1TokenSource.Token() function.
Body
The CreatePolicyRequest message is used to create a new policy.
The display name of the new policy.
The description of the new policy.
The map of policy type to policy steps. The key is the stringified version of the enum. See other policies for examples.
Show child attributes
Show child attributes
The enum of the policy type.
POLICY_TYPE_UNSPECIFIED, POLICY_TYPE_GRANT, POLICY_TYPE_REVOKE, POLICY_TYPE_CERTIFY, POLICY_TYPE_ACCESS_REQUEST, POLICY_TYPE_PROVISION Actions to occur after a policy finishes. As of now this is only valid on a certify policy to remediate a denied certification immediately.
Show child attributes
Show child attributes
Deprecated. Use setting in policy step instead
The rules field.
Show child attributes
Show child attributes
Response
The CreatePolicyResponse message contains the created policy object.
The CreatePolicyResponse message contains the created policy object.
A policy describes the behavior of the ConductorOne system when processing a task. You can describe the type, approvers, fallback behavior, and escalation processes.
Show child attributes
Show child attributes
Was this page helpful?